
"""
This file contains all residue names for modified amino acids linked to their
one letter standard parent amino acid.  This file is generated by the following
procedure:

  phenix.python elbow/elbow/scripts/process_amino_acid_parentage_from_chemical_componts.py

This file is intended to be generated monthly.
The date of file generation: Tue Jul 21 17:14:51 2020
"""
from __future__ import absolute_import, division, print_function

lookup = {
  "02K" : "A",
  "02O" : "A",
  "02Y" : "A",
  "0CS" : "A",
  "0FL" : "A",
  "0NC" : "A",
  "1AC" : "A",
  "1L1" : "A",
  "1PI" : "A",
  "23P" : "A",
  "2AG" : "A",
  "2RA" : "A",
  "33W" : "A",
  "3GA" : "A",
  "3WS" : "A",
  "4U7" : "A",
  "4WQ" : "A",
  "5AB" : "A",
  "5FQ" : "A",
  "5OH" : "A",
  "5XU" : "A",
  "6CV" : "A",
  "6GL" : "A",
  "7O5" : "A",
  "9WV" : "A",
  "AA3" : "A",
  "AA4" : "A",
  "ABA" : "A",
  "AHO" : "A",
  "AHP" : "A",
  "AIB" : "A",
  "ALC" : "A",
  "ALM" : "A",
  "ALN" : "A",
  "ALS" : "A",
  "ALT" : "A",
  "ALV" : "A",
  "AN8" : "A",
  "AYA" : "A",
  "AZH" : "A",
  "B2A" : "A",
  "B3A" : "A",
  "BP5" : "A",
  "C22" : "A",
  "CWD" : "A",
  "CZS" : "A",
  "DAB" : "A",
  "DBZ" : "A",
  "DDZ" : "A",
  "DNP" : "A",
  "DNW" : "A",
  "DPP" : "A",
  "FB5" : "A",
  "FB6" : "A",
  "FLA" : "A",
  "HAC" : "A",
  "HIX" : "A",
  "HQA" : "A",
  "HV5" : "A",
  "IAM" : "A",
  "KNB" : "A",
  "LAL" : "A",
  "MA" : "A",
  "MAA" : "A",
  "N9P" : "A",
  "NA8" : "A",
  "NAL" : "A",
  "NAM" : "A",
  "NCB" : "A",
  "NPI" : "A",
  "NWD" : "A",
  "ONH" : "A",
  "ORN" : "A",
  "PYA" : "A",
  "S2P" : "A",
  "SEG" : "A",
  "TIH" : "A",
  "UM1" : "A",
  "UM2" : "A",
  "UMA" : "A",
  "XW1" : "A",
  "XYC" : "A",
  "Z01" : "A",
  "ZZJ" : "A",
  "0AR" : "R",
  "0X9" : "R",
  "2MR" : "R",
  "2OR" : "R",
  "4AR" : "R",
  "4D4" : "R",
  "4J5" : "R",
  "73N" : "R",
  "9NR" : "R",
  "AAR" : "R",
  "ACL" : "R",
  "AGM" : "R",
  "AR2" : "R",
  "AR7" : "R",
  "ARM" : "R",
  "ARO" : "R",
  "BOR" : "R",
  "BWV" : "R",
  "CIR" : "R",
  "DA2" : "R",
  "DIR" : "R",
  "FIO" : "R",
  "G3M" : "R",
  "HAR" : "R",
  "HMR" : "R",
  "HR7" : "R",
  "HRG" : "R",
  "IAR" : "R",
  "IOR" : "R",
  "J9Y" : "R",
  "MAI" : "R",
  "MGG" : "R",
  "MMO" : "R",
  "MYN" : "R",
  "NMM" : "R",
  "NNH" : "R",
  "OAR" : "R",
  "ORQ" : "R",
  "POK" : "R",
  "RGL" : "R",
  "RPI" : "R",
  "THZ" : "R",
  "VR0" : "R",
  "02L" : "N",
  "41Q" : "N",
  "5VV" : "N",
  "823" : "N",
  "9DN" : "N",
  "A5N" : "N",
  "AFA" : "N",
  "AHB" : "N",
  "AS7" : "N",
  "B3X" : "N",
  "CE7" : "N",
  "DMH" : "N",
  "MEN" : "N",
  "SD4" : "N",
  "SNN" : "N",
  "XSN" : "N",
  "0A0" : "D",
  "0AK" : "D",
  "0TD" : "D",
  "3MD" : "D",
  "999" : "D",
  "AEI" : "D",
  "AKL" : "D",
  "AKZ" : "D",
  "ASA" : "D",
  "ASB" : "D",
  "ASI" : "D",
  "ASK" : "D",
  "ASL" : "D",
  "ASQ" : "D",
  "B3D" : "D",
  "BFD" : "D",
  "BH2" : "D",
  "BHD" : "D",
  "D2T" : "D",
  "DMK" : "D",
  "DOH" : "D",
  "DYA" : "D",
  "KKD" : "D",
  "LAA" : "D",
  "OHS" : "D",
  "OXX" : "D",
  "PAS" : "D",
  "PHD" : "D",
  "TAV" : "D",
  "03Y" : "C",
  "07O" : "C",
  "08P" : "C",
  "0A8" : "C",
  "0QL" : "C",
  "143" : "C",
  "2CO" : "C",
  "2XA" : "C",
  "30V" : "C",
  "31Q" : "C",
  "3X9" : "C",
  "4GJ" : "C",
  "4J4" : "C",
  "5CS" : "C",
  "60F" : "C",
  "6M6" : "C",
  "6V1" : "C",
  "6WK" : "C",
  "85F" : "C",
  "8JB" : "C",
  "AEA" : "C",
  "AGT" : "C",
  "BB6" : "C",
  "BB7" : "C",
  "BB9" : "C",
  "BBC" : "C",
  "BCS" : "C",
  "BCX" : "C",
  "BPE" : "C",
  "BTC" : "C",
  "BUC" : "C",
  "C1T" : "C",
  "C3Y" : "C",
  "C4R" : "C",
  "C5C" : "C",
  "C6C" : "C",
  "CAF" : "C",
  "CAS" : "C",
  "CAY" : "C",
  "CCS" : "C",
  "CEA" : "C",
  "CG6" : "C",
  "CGV" : "C",
  "CME" : "C",
  "CMH" : "C",
  "CML" : "C",
  "CMT" : "C",
  "CS0" : "C",
  "CS1" : "C",
  "CS3" : "C",
  "CS4" : "C",
  "CSA" : "C",
  "CSB" : "C",
  "CSD" : "C",
  "CSE" : "C",
  "CSJ" : "C",
  "CSO" : "C",
  "CSP" : "C",
  "CSR" : "C",
  "CSS" : "C",
  "CSU" : "C",
  "CSW" : "C",
  "CSX" : "C",
  "CSZ" : "C",
  "CY0" : "C",
  "CY1" : "C",
  "CY3" : "C",
  "CY4" : "C",
  "CYA" : "C",
  "CYD" : "C",
  "CYF" : "C",
  "CYG" : "C",
  "CYM" : "C",
  "CYQ" : "C",
  "CYR" : "C",
  "CYW" : "C",
  "CZ2" : "C",
  "CZZ" : "C",
  "DC2" : "C",
  "DYS" : "C",
  "ECX" : "C",
  "EFC" : "C",
  "EJA" : "C",
  "FFM" : "C",
  "FOE" : "C",
  "GT9" : "C",
  "HCM" : "C",
  "HNC" : "C",
  "HTI" : "C",
  "ICY" : "C",
  "J3D" : "C",
  "JJJ" : "C",
  "JJK" : "C",
  "JJL" : "C",
  "K1R" : "C",
  "K5H" : "C",
  "M0H" : "C",
  "MCS" : "C",
  "MD3" : "C",
  "MD5" : "C",
  "NPH" : "C",
  "NYB" : "C",
  "NYS" : "C",
  "OCS" : "C",
  "OCY" : "C",
  "P1L" : "C",
  "P9S" : "C",
  "PBB" : "C",
  "PEC" : "C",
  "PR3" : "C",
  "PYX" : "C",
  "QCS" : "C",
  "QPA" : "C",
  "R1A" : "C",
  "S2C" : "C",
  "SAH" : "C",
  "SCH" : "C",
  "SCS" : "C",
  "SCY" : "C",
  "SHC" : "C",
  "SIB" : "C",
  "SMC" : "C",
  "SNC" : "C",
  "SYS" : "C",
  "TNB" : "C",
  "TQZ" : "C",
  "TSY" : "C",
  "XCN" : "C",
  "YCM" : "C",
  "ZBZ" : "C",
  "ZZD" : "C",
  "ECC" : "Q",
  "GHG" : "Q",
  "GLH" : "Q",
  "GNC" : "Q",
  "LMQ" : "Q",
  "MEQ" : "Q",
  "MGN" : "Q",
  "NLQ" : "Q",
  "PCA" : "Q",
  "QMM" : "Q",
  "11W" : "E",
  "3GL" : "E",
  "3O3" : "E",
  "5HP" : "E",
  "9NE" : "E",
  "AR4" : "E",
  "B3E" : "E",
  "CGA" : "E",
  "CGU" : "E",
  "EME" : "E",
  "G01" : "E",
  "G8M" : "E",
  "GAU" : "E",
  "GHC" : "E",
  "GHW" : "E",
  "GLJ" : "E",
  "GLK" : "E",
  "GLQ" : "E",
  "GMA" : "E",
  "GME" : "E",
  "GSU" : "E",
  "ILG" : "E",
  "LME" : "E",
  "MEG" : "E",
  "X2W" : "E",
  "0AC" : "G",
  "3XH" : "G",
  "5PG" : "G",
  "9DS" : "G",
  "CHP" : "G",
  "CR5" : "G",
  "FGL" : "G",
  "GEE" : "G",
  "GL3" : "G",
  "GLZ" : "G",
  "GSC" : "G",
  "HGY" : "G",
  "I4G" : "G",
  "IGL" : "G",
  "IPG" : "G",
  "LPG" : "G",
  "LVG" : "G",
  "M30" : "G",
  "MD6" : "G",
  "MEU" : "G",
  "MGY" : "G",
  "MPQ" : "G",
  "MSA" : "G",
  "NLY" : "G",
  "NMC" : "G",
  "PGY" : "G",
  "PRV" : "G",
  "SAR" : "G",
  "SHP" : "G",
  "UGY" : "G",
  "2HF" : "H",
  "2SO" : "H",
  "3AH" : "H",
  "3ZH" : "H",
  "56A" : "H",
  "B3U" : "H",
  "DDE" : "H",
  "E9V" : "H",
  "HBN" : "H",
  "HHI" : "H",
  "HIA" : "H",
  "HIC" : "H",
  "HIP" : "H",
  "HIQ" : "H",
  "HOO" : "H",
  "HS8" : "H",
  "HS9" : "H",
  "HSK" : "H",
  "HSO" : "H",
  "HSV" : "H",
  "MH1" : "H",
  "MHS" : "H",
  "NEM" : "H",
  "NEP" : "H",
  "NZH" : "H",
  "OHI" : "H",
  "OLD" : "H",
  "OYL" : "H",
  "PSH" : "H",
  "PVH" : "H",
  "Z70" : "H",
  "5GM" : "I",
  "66D" : "I",
  "7JA" : "I",
  "B2I" : "I",
  "BIU" : "I",
  "I2M" : "I",
  "IIL" : "I",
  "ILM" : "I",
  "ILX" : "I",
  "IML" : "I",
  "QIL" : "I",
  "TS9" : "I",
  "0AG" : "L",
  "2LU" : "L",
  "2ML" : "L",
  "8WY" : "L",
  "AN6" : "L",
  "BL2" : "L",
  "BLE" : "L",
  "BTA" : "L",
  "CLE" : "L",
  "DON" : "L",
  "EXY" : "L",
  "FLE" : "L",
  "G5G" : "L",
  "HL2" : "L",
  "HL5" : "L",
  "HLU" : "L",
  "L3O" : "L",
  "LAY" : "L",
  "LED" : "L",
  "LEF" : "L",
  "LEH" : "L",
  "LEM" : "L",
  "LEN" : "L",
  "LEX" : "L",
  "LNE" : "L",
  "LNM" : "L",
  "MHL" : "L",
  "MK8" : "L",
  "MLE" : "L",
  "MLL" : "L",
  "MNL" : "L",
  "NLB" : "L",
  "NLE" : "L",
  "NLN" : "L",
  "NLO" : "L",
  "NLP" : "L",
  "NLW" : "L",
  "NOT" : "L",
  "WLU" : "L",
  "0A2" : "K",
  "2KK" : "K",
  "2KP" : "K",
  "3QN" : "K",
  "4AK" : "K",
  "5CT" : "K",
  "5GG" : "K",
  "5MW" : "K",
  "5OW" : "K",
  "5T3" : "K",
  "6CL" : "K",
  "6G4" : "K",
  "6HN" : "K",
  "73P" : "K",
  "74P" : "K",
  "8RE" : "K",
  "9E7" : "K",
  "9KP" : "K",
  "9TR" : "K",
  "9TU" : "K",
  "9TX" : "K",
  "9U0" : "K",
  "ALY" : "K",
  "API" : "K",
  "APK" : "K",
  "AZK" : "K",
  "B3K" : "K",
  "BLY" : "K",
  "BTK" : "K",
  "C1X" : "K",
  "CLG" : "K",
  "CLH" : "K",
  "CYJ" : "K",
  "DLS" : "K",
  "DM0" : "K",
  "DNL" : "K",
  "DNS" : "K",
  "ELY" : "K",
  "EXA" : "K",
  "FAK" : "K",
  "FDL" : "K",
  "FH7" : "K",
  "FHL" : "K",
  "FHO" : "K",
  "FQA" : "K",
  "FZN" : "K",
  "GPL" : "K",
  "HLY" : "K",
  "I58" : "K",
  "IEL" : "K",
  "IT1" : "K",
  "JLP" : "K",
  "KBE" : "K",
  "KCR" : "K",
  "KCX" : "K",
  "KEO" : "K",
  "KFP" : "K",
  "KGC" : "K",
  "KHB" : "K",
  "KPF" : "K",
  "KPI" : "K",
  "KPY" : "K",
  "KST" : "K",
  "KYQ" : "K",
  "L5P" : "K",
  "LA2" : "K",
  "LBY" : "K",
  "LCK" : "K",
  "LCX" : "K",
  "LDH" : "K",
  "LET" : "K",
  "LGY" : "K",
  "LLO" : "K",
  "LLP" : "K",
  "LLY" : "K",
  "LLZ" : "K",
  "LMF" : "K",
  "LP6" : "K",
  "LRK" : "K",
  "LSO" : "K",
  "LYF" : "K",
  "LYK" : "K",
  "LYM" : "K",
  "LYN" : "K",
  "LYO" : "K",
  "LYR" : "K",
  "LYU" : "K",
  "LYX" : "K",
  "LYZ" : "K",
  "M2L" : "K",
  "M3L" : "K",
  "M3R" : "K",
  "MCL" : "K",
  "ML3" : "K",
  "MLY" : "K",
  "MLZ" : "K",
  "MYK" : "K",
  "N65" : "K",
  "OBS" : "K",
  "PE1" : "K",
  "PRK" : "K",
  "PYH" : "K",
  "Q3P" : "K",
  "SHR" : "K",
  "SKH" : "K",
  "SLL" : "K",
  "SLZ" : "K",
  "TLY" : "K",
  "TRG" : "K",
  "VB1" : "K",
  "XOK" : "K",
  "XX1" : "K",
  "2FM" : "M",
  "4CY" : "M",
  "4MM" : "M",
  "CXM" : "M",
  "ESC" : "M",
  "FME" : "M",
  "IZO" : "M",
  "KOR" : "M",
  "M2S" : "M",
  "ME0" : "M",
  "MHO" : "M",
  "MME" : "M",
  "MSE" : "M",
  "MSL" : "M",
  "MSO" : "M",
  "MT2" : "M",
  "OMT" : "M",
  "SME" : "M",
  "0A9" : "F",
  "0BN" : "F",
  "1PA" : "F",
  "200" : "F",
  "23F" : "F",
  "2GX" : "F",
  "33S" : "F",
  "3CF" : "F",
  "41H" : "F",
  "4AF" : "F",
  "4CF" : "F",
  "4II" : "F",
  "4OU" : "F",
  "4PH" : "F",
  "4SJ" : "F",
  "5CR" : "F",
  "7N8" : "F",
  "7XC" : "F",
  "9NF" : "F",
  "B1F" : "F",
  "B2F" : "F",
  "BB8" : "F",
  "BIF" : "F",
  "BNN" : "F",
  "DAH" : "F",
  "DJD" : "F",
  "EHP" : "F",
  "F2F" : "F",
  "FC0" : "F",
  "FCL" : "F",
  "H14" : "F",
  "HOX" : "F",
  "HPC" : "F",
  "HPE" : "F",
  "HPH" : "F",
  "HPQ" : "F",
  "MEA" : "F",
  "MHU" : "F",
  "N0A" : "F",
  "NFA" : "F",
  "PBF" : "F",
  "PCS" : "F",
  "PF5" : "F",
  "PFF" : "F",
  "PHA" : "F",
  "PHI" : "F",
  "PHL" : "F",
  "PHM" : "F",
  "PM3" : "F",
  "PPN" : "F",
  "PSA" : "F",
  "QPH" : "F",
  "SMF" : "F",
  "T11" : "F",
  "TEF" : "F",
  "TFQ" : "F",
  "U3X" : "F",
  "WFP" : "F",
  "WPA" : "F",
  "ZCL" : "F",
  "037" : "P",
  "04U" : "P",
  "04V" : "P",
  "05N" : "P",
  "0LF" : "P",
  "0Y8" : "P",
  "11Q" : "P",
  "12L" : "P",
  "12X" : "P",
  "12Y" : "P",
  "2MT" : "P",
  "2P0" : "P",
  "3BY" : "P",
  "3PX" : "P",
  "3WX" : "P",
  "4FB" : "P",
  "4KY" : "P",
  "4L0" : "P",
  "4N7" : "P",
  "4N8" : "P",
  "4N9" : "P",
  "6Y9" : "P",
  "8LJ" : "P",
  "DPL" : "P",
  "DYJ" : "P",
  "E0Y" : "P",
  "FP9" : "P",
  "FPK" : "P",
  "H5M" : "P",
  "HY3" : "P",
  "HYP" : "P",
  "HZP" : "P",
  "JKH" : "P",
  "LPD" : "P",
  "LWY" : "P",
  "MP8" : "P",
  "N7P" : "P",
  "N80" : "P",
  "P2Y" : "P",
  "PCC" : "P",
  "PH6" : "P",
  "PKR" : "P",
  "PLJ" : "P",
  "POM" : "P",
  "PR4" : "P",
  "PR7" : "P",
  "PR9" : "P",
  "PRJ" : "P",
  "PRS" : "P",
  "PXU" : "P",
  "RT0" : "P",
  "TPJ" : "P",
  "TPK" : "P",
  "VH0" : "P",
  "XPR" : "P",
  "YPR" : "P",
  "ZPO" : "P",
  "ZYJ" : "P",
  "ZYK" : "P",
  "XPL" : "O",
  "30F" : "U",
  "PSW" : "U",
  "SE7" : "U",
  "SOC" : "U",
  "UOX" : "U",
  "0AH" : "S",
  "1X6" : "S",
  "2JG" : "S",
  "2RX" : "S",
  "2ZC" : "S",
  "432" : "S",
  "4HH" : "S",
  "4HJ" : "S",
  "4OV" : "S",
  "4OZ" : "S",
  "5R5" : "S",
  "73C" : "S",
  "8SP" : "S",
  "A9D" : "S",
  "AZS" : "S",
  "BG1" : "S",
  "BSE" : "S",
  "BWB" : "S",
  "BXT" : "S",
  "CWR" : "S",
  "DBS" : "S",
  "DHA" : "S",
  "FGP" : "S",
  "GFT" : "S",
  "GVL" : "S",
  "HSE" : "S",
  "HSL" : "S",
  "J8W" : "S",
  "K5L" : "S",
  "LPS" : "S",
  "MC1" : "S",
  "MH6" : "S",
  "MIR" : "S",
  "MIS" : "S",
  "N10" : "S",
  "NC1" : "S",
  "OAS" : "S",
  "OLZ" : "S",
  "OMH" : "S",
  "OSE" : "S",
  "PG1" : "S",
  "QDS" : "S",
  "RVX" : "S",
  "RZ4" : "S",
  "S12" : "S",
  "S1H" : "S",
  "SAC" : "S",
  "SBL" : "S",
  "SDP" : "S",
  "SEB" : "S",
  "SEE" : "S",
  "SEL" : "S",
  "SEM" : "S",
  "SEN" : "S",
  "SEP" : "S",
  "SET" : "S",
  "SGB" : "S",
  "SOY" : "S",
  "SRZ" : "S",
  "SUN" : "S",
  "SVA" : "S",
  "SVV" : "S",
  "SVW" : "S",
  "SVX" : "S",
  "SVY" : "S",
  "SVZ" : "S",
  "SXE" : "S",
  "TIS" : "S",
  "TNR" : "S",
  "UDS" : "S",
  "UF0" : "S",
  "0E5" : "T",
  "26B" : "T",
  "28X" : "T",
  "2QZ" : "T",
  "6BR" : "T",
  "ALO" : "T",
  "B27" : "T",
  "BMT" : "T",
  "CTH" : "T",
  "DBU" : "T",
  "EUP" : "T",
  "NZC" : "T",
  "O7A" : "T",
  "OLT" : "T",
  "OTH" : "T",
  "QNY" : "T",
  "T8L" : "T",
  "T9E" : "T",
  "TBM" : "T",
  "TH5" : "T",
  "TH6" : "T",
  "THC" : "T",
  "TMB" : "T",
  "TMD" : "T",
  "TNY" : "T",
  "TPO" : "T",
  "XDT" : "T",
  "YTH" : "T",
  "Z3E" : "T",
  "ZU0" : "T",
  "0AF" : "W",
  "0UO" : "W",
  "1TQ" : "W",
  "4AW" : "W",
  "4DP" : "W",
  "4FW" : "W",
  "4HT" : "W",
  "4IN" : "W",
  "4PQ" : "W",
  "54C" : "W",
  "5CW" : "W",
  "6CW" : "W",
  "BTR" : "W",
  "CTE" : "W",
  "E9M" : "W",
  "F7W" : "W",
  "FT6" : "W",
  "FTR" : "W",
  "HRP" : "W",
  "HT7" : "W",
  "HTR" : "W",
  "KYN" : "W",
  "LTR" : "W",
  "O7D" : "W",
  "PAT" : "W",
  "R4K" : "W",
  "RE0" : "W",
  "RE3" : "W",
  "TCR" : "W",
  "TGH" : "W",
  "TNQ" : "W",
  "TOQ" : "W",
  "TOX" : "W",
  "TPL" : "W",
  "TQI" : "W",
  "TQQ" : "W",
  "TRF" : "W",
  "TRN" : "W",
  "TRO" : "W",
  "TRQ" : "W",
  "TRW" : "W",
  "TRX" : "W",
  "TRY" : "W",
  "TTQ" : "W",
  "WRP" : "W",
  "ZIQ" : "W",
  "0A1" : "Y",
  "0EA" : "Y",
  "0PR" : "Y",
  "0WZ" : "Y",
  "1OP" : "Y",
  "1TY" : "Y",
  "2LT" : "Y",
  "2R3" : "Y",
  "2TY" : "Y",
  "3CT" : "Y",
  "3MY" : "Y",
  "3NF" : "Y",
  "3YM" : "Y",
  "4BF" : "Y",
  "4HL" : "Y",
  "4LZ" : "Y",
  "51T" : "Y",
  "73O" : "Y",
  "AGQ" : "Y",
  "AZY" : "Y",
  "B3Y" : "Y",
  "BYR" : "Y",
  "DBY" : "Y",
  "DI7" : "Y",
  "DPQ" : "Y",
  "E9C" : "Y",
  "ESB" : "Y",
  "F7Q" : "Y",
  "FLT" : "Y",
  "FTY" : "Y",
  "FY2" : "Y",
  "FY3" : "Y",
  "IYR" : "Y",
  "MBQ" : "Y",
  "MDF" : "Y",
  "MTY" : "Y",
  "NBQ" : "Y",
  "NIY" : "Y",
  "NTR" : "Y",
  "NTY" : "Y",
  "OMX" : "Y",
  "OMY" : "Y",
  "P2Q" : "Y",
  "P3Q" : "Y",
  "PAQ" : "Y",
  "PTH" : "Y",
  "PTM" : "Y",
  "PTR" : "Y",
  "STY" : "Y",
  "T0I" : "Y",
  "TCQ" : "Y",
  "TPQ" : "Y",
  "TTS" : "Y",
  "TXY" : "Y",
  "TY1" : "Y",
  "TY2" : "Y",
  "TY3" : "Y",
  "TY5" : "Y",
  "TY8" : "Y",
  "TY9" : "Y",
  "TYB" : "Y",
  "TYE" : "Y",
  "TYI" : "Y",
  "TYJ" : "Y",
  "TYN" : "Y",
  "TYO" : "Y",
  "TYQ" : "Y",
  "TYS" : "Y",
  "TYT" : "Y",
  "TYW" : "Y",
  "TYY" : "Y",
  "U2X" : "Y",
  "YOF" : "Y",
  "YPZ" : "Y",
  "0AA" : "V",
  "0AB" : "V",
  "2VA" : "V",
  "34E" : "V",
  "9NV" : "V",
  "A8E" : "V",
  "B2V" : "V",
  "BUG" : "V",
  "DHN" : "V",
  "FVA" : "V",
  "HVA" : "V",
  "LE1" : "V",
  "LVN" : "V",
  "MNV" : "V",
  "MVA" : "V",
  "NVA" : "V",
  "O7G" : "V",
  "TBG" : "V",
  "VAD" : "V",
  "VAF" : "V",
  "VAH" : "V",
  "VAI" : "V",
  "WVL" : "V",
}
if __name__ == '__main__':
  print(len(lookup.keys()))
