/*
This file contains all residue names for modified RNA/DNAs.
This file is generated by the following procedure:

  phenix.python elbow/elbow/scripts/process_amino_acid_parentage_from_chemical_componts.py

This file is intended to be generated monthly.
The date of file generation: Tue Jul 21 17:14:51 2020
*/

#include <string>
#include <set>

namespace iotbx { namespace pdb { namespace common_residue_names {

  static const char* modified_rna_dna[] = {
    "12A", // parent is A
    "1MA",
    "2MA",
    "31H",
    "31M",
    "45A",
    "5FA",
    "6IA",
    "6MA",
    "6MC",
    "6MT",
    "6MZ",
    "6NW",
    "7AT",
    "8AN",
    "A23",
    "A2L",
    "A2M",
    "A39",
    "A3P",
    "A44",
    "A5O",
    "A6A",
    "A7E",
    "A9Z",
    "AET",
    "AP7",
    "AVC",
    "F3N",
    "LCA",
    "M7A",
    "MA6",
    "MAD",
    "MGQ",
    "MIA",
    "MTU",
    "O2Z",
    "P5P",
    "PPU",
    "PR5",
    "PU",
    "RIA",
    "SRA",
    "T6A",
    "V3L",
    "ZAD",
    "10C", // parent is C
    "1SC",
    "4OC",
    "5HM",
    "5IC",
    "5MC",
    "6OO",
    "73W",
    "A5M",
    "A6C",
    "B8Q",
    "B8T",
    "B9H",
    "C25",
    "C2L",
    "C31",
    "C43",
    "C5L",
    "CBV",
    "CCC",
    "CH",
    "CSF",
    "E3C",
    "IC",
    "JMH",
    "LC",
    "LHH",
    "M4C",
    "M5M",
    "N5M",
    "OMC",
    "PMT",
    "RPC",
    "RSP",
    "RSQ",
    "S4C",
    "TC",
    "ZBC",
    "ZCY",
    "0AM", // parent is DA
    "0AV",
    "0SP",
    "1AP",
    "2AR",
    "2BU",
    "2DA",
    "3DA",
    "5AA",
    "6HA",
    "6HB",
    "7DA",
    "8BA",
    "A34",
    "A35",
    "A38",
    "A3A",
    "A40",
    "A43",
    "A47",
    "A5L",
    "ABR",
    "ABS",
    "AD2",
    "AF2",
    "AS",
    "DZM",
    "E",
    "E1X",
    "EDA",
    "FA2",
    "MA7",
    "PRN",
    "R",
    "RBD",
    "RMP",
    "S4A",
    "SDE",
    "SMP",
    "TCY",
    "TFO",
    "XAD",
    "XAL",
    "XUA",
    "Y",
    "0AP", // parent is DC
    "0R8",
    "1CC",
    "1FC",
    "47C",
    "4PC",
    "4PD",
    "4PE",
    "4SC",
    "4U3",
    "5CM",
    "5FC",
    "5HC",
    "5NC",
    "5PC",
    "6HC",
    "8RO",
    "8YN",
    "B7C",
    "C2S",
    "C32",
    "C34",
    "C36",
    "C37",
    "C38",
    "C42",
    "C45",
    "C46",
    "C49",
    "C4S",
    "C7R",
    "C7S",
    "CAR",
    "CB2",
    "CBR",
    "CDW",
    "CFL",
    "CFZ",
    "CMR",
    "CP1",
    "CSL",
    "CX2",
    "D00",
    "D4B",
    "DCT",
    "DFC",
    "DNR",
    "DOC",
    "EXC",
    "F7H",
    "GCK",
    "I5C",
    "IMC",
    "MCY",
    "ME6",
    "NCU",
    "OKN",
    "OKQ",
    "PVX",
    "SC",
    "TC1",
    "TCJ",
    "TPC",
    "XCL",
    "XCR",
    "XCT",
    "XCY",
    "YCO",
    "Z",
    "0AD", // parent is DG
    "0UH",
    "2JV",
    "2PR",
    "5CG",
    "63G",
    "63H",
    "68Z",
    "6FK",
    "6HG",
    "6OG",
    "6PO",
    "7BG",
    "7GU",
    "8AG",
    "8FG",
    "8MG",
    "8OG",
    "8PY",
    "AFG",
    "BGM",
    "C6G",
    "DCG",
    "DDG",
    "DFG",
    "DG8",
    "DGI",
    "EHG",
    "F4Q",
    "F74",
    "F7K",
    "FDG",
    "FMG",
    "FOX",
    "G2S",
    "G31",
    "G32",
    "G33",
    "G36",
    "G38",
    "G42",
    "G47",
    "G49",
    "GDR",
    "GF2",
    "GFL",
    "GMS",
    "GN7",
    "GS",
    "GSR",
    "GSS",
    "GX1",
    "HN0",
    "HN1",
    "IGU",
    "LCG",
    "LGP",
    "M1G",
    "MFO",
    "MG1",
    "MRG",
    "OGX",
    "P",
    "PG7",
    "PGN",
    "PPW",
    "PZG",
    "RDG",
    "S4G",
    "S6G",
    "SDG",
    "SDH",
    "TGP",
    "X",
    "XGL",
    "XGR",
    "XGU",
    "XPB",
    "XUG",
    "2BD", // parent is DI
    "OIP",
    "2AT", // parent is DT
    "2BT",
    "2DT",
    "2GT",
    "2NT",
    "2OT",
    "2ST",
    "5AT",
    "5HT",
    "5IT",
    "5PY",
    "64T",
    "6CT",
    "6HT",
    "94O",
    "ATD",
    "ATL",
    "ATM",
    "BOE",
    "CTG",
    "D3T",
    "D4M",
    "DPB",
    "DRT",
    "EAN",
    "EIT",
    "F3H",
    "F4H",
    "JDT",
    "LSH",
    "LST",
    "MMT",
    "MTR",
    "NMS",
    "NMT",
    "NTT",
    "P2T",
    "PST",
    "S2M",
    "SMT",
    "SPT",
    "T32",
    "T36",
    "T37",
    "T38",
    "T39",
    "T3P",
    "T41",
    "T48",
    "T49",
    "T4S",
    "T5S",
    "T64",
    "TA3",
    "TAF",
    "TCP",
    "TDY",
    "TED",
    "TFE",
    "TFF",
    "TFT",
    "TLC",
    "TP1",
    "TSP",
    "TTD",
    "TTM",
    "US3",
    "XTF",
    "XTH",
    "XTL",
    "XTR",
    "0AU", // parent is DU
    "18Q",
    "5HU",
    "5IU",
    "5SE",
    "77Y",
    "8DT",
    "BRU",
    "BVP",
    "DDN",
    "DRM",
    "DUZ",
    "GMU",
    "HDP",
    "HEU",
    "NDN",
    "NDU",
    "OHU",
    "OKT",
    "P2U",
    "PDU",
    "T5O",
    "TLN",
    "TTI",
    "U2N",
    "U33",
    "UBI",
    "UBR",
    "UCL",
    "UF2",
    "UFR",
    "UFT",
    "UMS",
    "UMX",
    "UPE",
    "UPS",
    "URX",
    "US1",
    "US2",
    "USM",
    "UVX",
    "ZDU",
    "18M", // parent is G
    "1MG",
    "23G",
    "2EG",
    "2MG",
    "2SG",
    "7MG",
    "8AA",
    "8OS",
    "A6G",
    "B8K",
    "B8W",
    "B9B",
    "BGH",
    "CG1",
    "E6G",
    "E7G",
    "EQ4",
    "G25",
    "G2L",
    "G46",
    "G48",
    "G7M",
    "GAO",
    "GDO",
    "GDP",
    "GH3",
    "GOM",
    "GRB",
    "IG",
    "KAG",
    "KAK",
    "LG",
    "M2G",
    "MGV",
    "MHG",
    "N6G",
    "O2G",
    "OMG",
    "P7G",
    "PGP",
    "QUO",
    "RFJ",
    "TG",
    "TPG",
    "XTS",
    "YG",
    "YYG",
    "ZGU",
    "8RJ", // parent is T
    "92F",
    "QBT",
    "RT",
    "T23",
    "T2S",
    "ZTH",
    "125", // parent is U
    "126",
    "127",
    "1RN",
    "2AU",
    "2MU",
    "2OM",
    "3AU",
    "3ME",
    "3MU",
    "3TD",
    "4SU",
    "5BU",
    "5FU",
    "5MU",
    "70U",
    "75B",
    "85Y",
    "9QV",
    "A6U",
    "B8H",
    "CNU",
    "DHU",
    "F2T",
    "FHU",
    "FNU",
    "H2U",
    "I4U",
    "IU",
    "LHU",
    "MEP",
    "MNU",
    "OMU",
    "ONE",
    "P4U",
    "PSU",
    "PYO",
    "RUS",
    "S4U",
    "SSU",
    "SUR",
    "T31",
    "U25",
    "U2L",
    "U2P",
    "U31",
    "U34",
    "U36",
    "U37",
    "U8U",
    "UAR",
    "UBD",
    "UD5",
    "UPV",
    "UR3",
    "URD",
    "US5",
    "ZBU",
    0
  };


}}} // namespace iotbx::pdb::common_residue_names
