
"""
This file contains all residue names for modified RNA/DNAs linked to their
one letter standard parent RNA/DNA.  This file is generated by the following
procedure:

  phenix.python elbow/elbow/scripts/process_amino_acid_parentage_from_chemical_componts.py

This file is intended to be generated monthly.
The date of file generation: Tue Jul 21 17:14:52 2020
"""
from __future__ import absolute_import, division, print_function

lookup = {
  "12A" : "A",
  "1MA" : "A",
  "2MA" : "A",
  "31H" : "A",
  "31M" : "A",
  "45A" : "A",
  "5FA" : "A",
  "6IA" : "A",
  "6MA" : "A",
  "6MC" : "A",
  "6MT" : "A",
  "6MZ" : "A",
  "6NW" : "A",
  "7AT" : "A",
  "8AN" : "A",
  "A23" : "A",
  "A2L" : "A",
  "A2M" : "A",
  "A39" : "A",
  "A3P" : "A",
  "A44" : "A",
  "A5O" : "A",
  "A6A" : "A",
  "A7E" : "A",
  "A9Z" : "A",
  "AET" : "A",
  "AP7" : "A",
  "AVC" : "A",
  "F3N" : "A",
  "LCA" : "A",
  "M7A" : "A",
  "MA6" : "A",
  "MAD" : "A",
  "MGQ" : "A",
  "MIA" : "A",
  "MTU" : "A",
  "O2Z" : "A",
  "P5P" : "A",
  "PPU" : "A",
  "PR5" : "A",
  "PU" : "A",
  "RIA" : "A",
  "SRA" : "A",
  "T6A" : "A",
  "V3L" : "A",
  "ZAD" : "A",
  "10C" : "C",
  "1SC" : "C",
  "4OC" : "C",
  "5HM" : "C",
  "5IC" : "C",
  "5MC" : "C",
  "6OO" : "C",
  "73W" : "C",
  "A5M" : "C",
  "A6C" : "C",
  "B8Q" : "C",
  "B8T" : "C",
  "B9H" : "C",
  "C25" : "C",
  "C2L" : "C",
  "C31" : "C",
  "C43" : "C",
  "C5L" : "C",
  "CBV" : "C",
  "CCC" : "C",
  "CH" : "C",
  "CSF" : "C",
  "E3C" : "C",
  "IC" : "C",
  "JMH" : "C",
  "LC" : "C",
  "LHH" : "C",
  "M4C" : "C",
  "M5M" : "C",
  "N5M" : "C",
  "OMC" : "C",
  "PMT" : "C",
  "RPC" : "C",
  "RSP" : "C",
  "RSQ" : "C",
  "S4C" : "C",
  "TC" : "C",
  "ZBC" : "C",
  "ZCY" : "C",
  "0AM" : "DA",
  "0AV" : "DA",
  "0SP" : "DA",
  "1AP" : "DA",
  "2AR" : "DA",
  "2BU" : "DA",
  "2DA" : "DA",
  "3DA" : "DA",
  "5AA" : "DA",
  "6HA" : "DA",
  "6HB" : "DA",
  "7DA" : "DA",
  "8BA" : "DA",
  "A34" : "DA",
  "A35" : "DA",
  "A38" : "DA",
  "A3A" : "DA",
  "A40" : "DA",
  "A43" : "DA",
  "A47" : "DA",
  "A5L" : "DA",
  "ABR" : "DA",
  "ABS" : "DA",
  "AD2" : "DA",
  "AF2" : "DA",
  "AS" : "DA",
  "DZM" : "DA",
  "E" : "DA",
  "E1X" : "DA",
  "EDA" : "DA",
  "FA2" : "DA",
  "MA7" : "DA",
  "PRN" : "DA",
  "R" : "DA",
  "RBD" : "DA",
  "RMP" : "DA",
  "S4A" : "DA",
  "SDE" : "DA",
  "SMP" : "DA",
  "TCY" : "DA",
  "TFO" : "DA",
  "XAD" : "DA",
  "XAL" : "DA",
  "XUA" : "DA",
  "Y" : "DA",
  "0AP" : "DC",
  "0R8" : "DC",
  "1CC" : "DC",
  "1FC" : "DC",
  "47C" : "DC",
  "4PC" : "DC",
  "4PD" : "DC",
  "4PE" : "DC",
  "4SC" : "DC",
  "4U3" : "DC",
  "5CM" : "DC",
  "5FC" : "DC",
  "5HC" : "DC",
  "5NC" : "DC",
  "5PC" : "DC",
  "6HC" : "DC",
  "8RO" : "DC",
  "8YN" : "DC",
  "B7C" : "DC",
  "C2S" : "DC",
  "C32" : "DC",
  "C34" : "DC",
  "C36" : "DC",
  "C37" : "DC",
  "C38" : "DC",
  "C42" : "DC",
  "C45" : "DC",
  "C46" : "DC",
  "C49" : "DC",
  "C4S" : "DC",
  "C7R" : "DC",
  "C7S" : "DC",
  "CAR" : "DC",
  "CB2" : "DC",
  "CBR" : "DC",
  "CDW" : "DC",
  "CFL" : "DC",
  "CFZ" : "DC",
  "CMR" : "DC",
  "CP1" : "DC",
  "CSL" : "DC",
  "CX2" : "DC",
  "D00" : "DC",
  "D4B" : "DC",
  "DCT" : "DC",
  "DFC" : "DC",
  "DNR" : "DC",
  "DOC" : "DC",
  "EXC" : "DC",
  "F7H" : "DC",
  "GCK" : "DC",
  "I5C" : "DC",
  "IMC" : "DC",
  "MCY" : "DC",
  "ME6" : "DC",
  "NCU" : "DC",
  "OKN" : "DC",
  "OKQ" : "DC",
  "PVX" : "DC",
  "SC" : "DC",
  "TC1" : "DC",
  "TCJ" : "DC",
  "TPC" : "DC",
  "XCL" : "DC",
  "XCR" : "DC",
  "XCT" : "DC",
  "XCY" : "DC",
  "YCO" : "DC",
  "Z" : "DC",
  "0AD" : "DG",
  "0UH" : "DG",
  "2JV" : "DG",
  "2PR" : "DG",
  "5CG" : "DG",
  "63G" : "DG",
  "63H" : "DG",
  "68Z" : "DG",
  "6FK" : "DG",
  "6HG" : "DG",
  "6OG" : "DG",
  "6PO" : "DG",
  "7BG" : "DG",
  "7GU" : "DG",
  "8AG" : "DG",
  "8FG" : "DG",
  "8MG" : "DG",
  "8OG" : "DG",
  "8PY" : "DG",
  "AFG" : "DG",
  "BGM" : "DG",
  "C6G" : "DG",
  "DCG" : "DG",
  "DDG" : "DG",
  "DFG" : "DG",
  "DG8" : "DG",
  "DGI" : "DG",
  "EHG" : "DG",
  "F4Q" : "DG",
  "F74" : "DG",
  "F7K" : "DG",
  "FDG" : "DG",
  "FMG" : "DG",
  "FOX" : "DG",
  "G2S" : "DG",
  "G31" : "DG",
  "G32" : "DG",
  "G33" : "DG",
  "G36" : "DG",
  "G38" : "DG",
  "G42" : "DG",
  "G47" : "DG",
  "G49" : "DG",
  "GDR" : "DG",
  "GF2" : "DG",
  "GFL" : "DG",
  "GMS" : "DG",
  "GN7" : "DG",
  "GS" : "DG",
  "GSR" : "DG",
  "GSS" : "DG",
  "GX1" : "DG",
  "HN0" : "DG",
  "HN1" : "DG",
  "IGU" : "DG",
  "LCG" : "DG",
  "LGP" : "DG",
  "M1G" : "DG",
  "MFO" : "DG",
  "MG1" : "DG",
  "MRG" : "DG",
  "OGX" : "DG",
  "P" : "DG",
  "PG7" : "DG",
  "PGN" : "DG",
  "PPW" : "DG",
  "PZG" : "DG",
  "RDG" : "DG",
  "S4G" : "DG",
  "S6G" : "DG",
  "SDG" : "DG",
  "SDH" : "DG",
  "TGP" : "DG",
  "X" : "DG",
  "XGL" : "DG",
  "XGR" : "DG",
  "XGU" : "DG",
  "XPB" : "DG",
  "XUG" : "DG",
  "2BD" : "DI",
  "OIP" : "DI",
  "2AT" : "DT",
  "2BT" : "DT",
  "2DT" : "DT",
  "2GT" : "DT",
  "2NT" : "DT",
  "2OT" : "DT",
  "2ST" : "DT",
  "5AT" : "DT",
  "5HT" : "DT",
  "5IT" : "DT",
  "5PY" : "DT",
  "64T" : "DT",
  "6CT" : "DT",
  "6HT" : "DT",
  "94O" : "DT",
  "ATD" : "DT",
  "ATL" : "DT",
  "ATM" : "DT",
  "BOE" : "DT",
  "CTG" : "DT",
  "D3T" : "DT",
  "D4M" : "DT",
  "DPB" : "DT",
  "DRT" : "DT",
  "EAN" : "DT",
  "EIT" : "DT",
  "F3H" : "DT",
  "F4H" : "DT",
  "JDT" : "DT",
  "LSH" : "DT",
  "LST" : "DT",
  "MMT" : "DT",
  "MTR" : "DT",
  "NMS" : "DT",
  "NMT" : "DT",
  "NTT" : "DT",
  "P2T" : "DT",
  "PST" : "DT",
  "S2M" : "DT",
  "SMT" : "DT",
  "SPT" : "DT",
  "T32" : "DT",
  "T36" : "DT",
  "T37" : "DT",
  "T38" : "DT",
  "T39" : "DT",
  "T3P" : "DT",
  "T41" : "DT",
  "T48" : "DT",
  "T49" : "DT",
  "T4S" : "DT",
  "T5S" : "DT",
  "T64" : "DT",
  "TA3" : "DT",
  "TAF" : "DT",
  "TCP" : "DT",
  "TDY" : "DT",
  "TED" : "DT",
  "TFE" : "DT",
  "TFF" : "DT",
  "TFT" : "DT",
  "TLC" : "DT",
  "TP1" : "DT",
  "TSP" : "DT",
  "TTD" : "DT",
  "TTM" : "DT",
  "US3" : "DT",
  "XTF" : "DT",
  "XTH" : "DT",
  "XTL" : "DT",
  "XTR" : "DT",
  "0AU" : "DU",
  "18Q" : "DU",
  "5HU" : "DU",
  "5IU" : "DU",
  "5SE" : "DU",
  "77Y" : "DU",
  "8DT" : "DU",
  "BRU" : "DU",
  "BVP" : "DU",
  "DDN" : "DU",
  "DRM" : "DU",
  "DUZ" : "DU",
  "GMU" : "DU",
  "HDP" : "DU",
  "HEU" : "DU",
  "NDN" : "DU",
  "NDU" : "DU",
  "OHU" : "DU",
  "OKT" : "DU",
  "P2U" : "DU",
  "PDU" : "DU",
  "T5O" : "DU",
  "TLN" : "DU",
  "TTI" : "DU",
  "U2N" : "DU",
  "U33" : "DU",
  "UBI" : "DU",
  "UBR" : "DU",
  "UCL" : "DU",
  "UF2" : "DU",
  "UFR" : "DU",
  "UFT" : "DU",
  "UMS" : "DU",
  "UMX" : "DU",
  "UPE" : "DU",
  "UPS" : "DU",
  "URX" : "DU",
  "US1" : "DU",
  "US2" : "DU",
  "USM" : "DU",
  "UVX" : "DU",
  "ZDU" : "DU",
  "18M" : "G",
  "1MG" : "G",
  "23G" : "G",
  "2EG" : "G",
  "2MG" : "G",
  "2SG" : "G",
  "7MG" : "G",
  "8AA" : "G",
  "8OS" : "G",
  "A6G" : "G",
  "B8K" : "G",
  "B8W" : "G",
  "B9B" : "G",
  "BGH" : "G",
  "CG1" : "G",
  "E6G" : "G",
  "E7G" : "G",
  "EQ4" : "G",
  "G25" : "G",
  "G2L" : "G",
  "G46" : "G",
  "G48" : "G",
  "G7M" : "G",
  "GAO" : "G",
  "GDO" : "G",
  "GDP" : "G",
  "GH3" : "G",
  "GOM" : "G",
  "GRB" : "G",
  "IG" : "G",
  "KAG" : "G",
  "KAK" : "G",
  "LG" : "G",
  "M2G" : "G",
  "MGV" : "G",
  "MHG" : "G",
  "N6G" : "G",
  "O2G" : "G",
  "OMG" : "G",
  "P7G" : "G",
  "PGP" : "G",
  "QUO" : "G",
  "RFJ" : "G",
  "TG" : "G",
  "TPG" : "G",
  "XTS" : "G",
  "YG" : "G",
  "YYG" : "G",
  "ZGU" : "G",
  "8RJ" : "T",
  "92F" : "T",
  "QBT" : "T",
  "RT" : "T",
  "T23" : "T",
  "T2S" : "T",
  "ZTH" : "T",
  "125" : "U",
  "126" : "U",
  "127" : "U",
  "1RN" : "U",
  "2AU" : "U",
  "2MU" : "U",
  "2OM" : "U",
  "3AU" : "U",
  "3ME" : "U",
  "3MU" : "U",
  "3TD" : "U",
  "4SU" : "U",
  "5BU" : "U",
  "5FU" : "U",
  "5MU" : "U",
  "70U" : "U",
  "75B" : "U",
  "85Y" : "U",
  "9QV" : "U",
  "A6U" : "U",
  "B8H" : "U",
  "CNU" : "U",
  "DHU" : "U",
  "F2T" : "U",
  "FHU" : "U",
  "FNU" : "U",
  "H2U" : "U",
  "I4U" : "U",
  "IU" : "U",
  "LHU" : "U",
  "MEP" : "U",
  "MNU" : "U",
  "OMU" : "U",
  "ONE" : "U",
  "P4U" : "U",
  "PSU" : "U",
  "PYO" : "U",
  "RUS" : "U",
  "S4U" : "U",
  "SSU" : "U",
  "SUR" : "U",
  "T31" : "U",
  "U25" : "U",
  "U2L" : "U",
  "U2P" : "U",
  "U31" : "U",
  "U34" : "U",
  "U36" : "U",
  "U37" : "U",
  "U8U" : "U",
  "UAR" : "U",
  "UBD" : "U",
  "UD5" : "U",
  "UPV" : "U",
  "UR3" : "U",
  "URD" : "U",
  "US5" : "U",
  "ZBU" : "U",
}
if __name__ == '__main__':
  print(len(lookup.keys()))
